<?php /*
Plugin Name: RV Thumbs
Version: 2.1.a
Description: Let users see a variable number of thumbnails on index page
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=261
Author: rvelices
Author URI: http://www.modusoptimus.com/
*/

define('RV_THUMBS_MAX', 384);

add_event_handler('loc_begin_index', 'rv_thumbs_begin_index' );

function rv_thumbs_begin_index()
{
	global $page;
	$multiplier = pwg_get_session_var('idx_thumbs_muliplier', 1);
	if (isset($_GET['thumbs']))
	{
		$page['meta_robots']['noindex']=1;
		switch ($_GET['thumbs'])
		{
			case 'more':
				if (count($page['items']) > $page['nb_image_page'] * $multiplier)
				{
					$multiplier = ($multiplier==1) ? 4 : $multiplier*2;
					$multiplier = min($multiplier, ceil(RV_THUMBS_MAX/$page['nb_image_page']));
				}
				break;
			case 'less':
				$multiplier = ($multiplier==4) ? 1 : (int)$multiplier/2;
				$multiplier = max(1, $multiplier);
				break;
		}
		if ($multiplier>1)
			pwg_set_session_var('idx_thumbs_muliplier', $multiplier);
		else
			pwg_unset_session_var('idx_thumbs_muliplier');
	}
	$page['nb_image_page'] *= $multiplier;
	if ( count($page['items']) )
		add_event_handler('loc_end_index', 'rv_thumbs_end_index' );
}

function rv_thumbs_end_index()
{
	global $user, $template, $page;
	$multiplier = pwg_get_session_var('idx_thumbs_muliplier', 1);
	$title = & $template->get_template_vars('TITLE');
	$ini_per_page = $user['nb_image_page'];
	$has_less = $multiplier>1 && count($page['items'])>$ini_per_page;
	$has_more = !empty($page['navigation_bar']) && $multiplier < ceil(RV_THUMBS_MAX/$ini_per_page );
	if ($has_less || $has_more)
	{
		global $lang_info, $conf; if ($lang_info['code']!='en' or $conf['debug_l10n']) load_language( 'lang', dirname(__FILE__).'/' );
		$css = 'background:url('.get_root_url().'plugins/rv_thumbs/sprite.gif) no-repeat top left; height:15px; width:17px; padding:0 5px 1px 0; display:inline-block; background-position:center ';
		$fmt_link = '<a href="%s" rel="nofollow" style="border:none; margin:0;"><div style="'.$css.'%spx;" title="%s">&nbsp;</div></a>';
		$fmt = '<div style="'.$css.'%spx; cursor:default" title="%s">&nbsp;</div>';
		$bar = '<span style="margin-left:10px;vertical-align:middle;">';
		if ($has_less)
			$bar .= sprintf( $fmt_link, add_url_params(duplicate_index_url(), array('thumbs'=>'less')), -39, l10n('Show less thumbnails') );
		else
			$bar .= sprintf( $fmt, -57, l10n('Show less thumbnails') );
		if ($has_more)
			$bar .= sprintf( $fmt_link, add_url_params(duplicate_index_url(array('start'=>0)), array('thumbs'=>'more')), -3, l10n('Show more thumbnails') );
		else
			$bar .= sprintf( $fmt, -21, l10n('Show more thumbnails') );
		$bar .= '</span>';
		$title .= $bar;
	}
}
?>